Index: /java/main/src/main/java/com/framsticks/parsers/MultiParamLoader.java
===================================================================
--- /java/main/src/main/java/com/framsticks/parsers/MultiParamLoader.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/parsers/MultiParamLoader.java	(revision 86)
@@ -9,6 +9,5 @@
 
 public class MultiParamLoader {
-	private final static Logger logger = Logger
-			.getLogger(MultiParamLoader.class.getName());
+	private final static Logger log = Logger.getLogger(MultiParamLoader.class);
 
 	/**
@@ -56,5 +55,10 @@
 	 * Status of current execution.
 	 */
-	private Status status;
+	private Status status = Status.None;
+
+	private void setStatus(Status status) {
+		log.trace("changing status: " + this.status.toString() + " -> " + status.toString());
+		this.status = status;
+	}
 
 	/**
@@ -62,4 +66,6 @@
 	 */
 	private SourceInterface currentSource;
+
+	protected String currentLine;
 
 
@@ -86,4 +92,11 @@
 	private String lastUnknownObjectName;
 
+	/**
+	 * @return the currentLine
+	 */
+	public String getCurrentLine() {
+		return currentLine;
+	}
+
 	public MultiParamLoader() {
 
@@ -94,5 +107,5 @@
 	 */
 	public Status go() throws Exception {
-		logger.trace("go");
+		log.trace("go");
 
 		while (!isFinished()) {
@@ -106,8 +119,8 @@
 
 			// read data
-			String line = currentSource.readLine();
+			currentLine = currentSource.readLine();
 
 			// end of file
-			if (line == null) {
+			if (currentLine == null) {
 				if (!returnFromIncluded()) {
 					finish();
@@ -117,24 +130,30 @@
 				}
 			}
+			log.trace("read line: " + currentLine);
 
 			// empty line
-			if (line.length() == 0) {
+			if (currentLine.length() == 0) {
 				continue;
 			}
 
 			// check if some file should be included
-			if (isIncludeLine(line) == LoopAction.Continue) {
+			if (isIncludeLine(currentLine) == LoopAction.Continue) {
 				continue;
 			}
 
 			// check if should break on comment
-			if (isCommentLine(line) == LoopAction.Break) {
+			if (isCommentLine(currentLine) == LoopAction.Break) {
 				break;
 			}
 
 			// get class getName
-			if (changeCurrentParamInterface(line) == LoopAction.Break) {
+			LoopAction action = changeCurrentParamInterface(currentLine);
+			if (action == LoopAction.Break) {
 				break;
 			}
+			if (action == LoopAction.Continue) {
+				continue;
+			}
+			log.warn("unknown line: " + currentLine);
 		}
 
@@ -145,4 +164,5 @@
 	 * Checks whether the reader found a known or unknown object and execution
 	 * should be passed to it.
+	 * @throws Exception
 	 */
 	private LoopAction tryReadObject() throws Exception {
@@ -150,7 +170,8 @@
 				|| (status == Status.BeforeUnknown && lastAccessInterface != null)) {
 			// found object - let it load data
-            if (lastAccessInterface.getSelected() == null) {
-                lastAccessInterface.select(lastAccessInterface.createAccessee());
-            }
+			if (lastAccessInterface.getSelected() == null) {
+				lastAccessInterface.select(lastAccessInterface.createAccessee());
+			}
+			log.trace("loading into " + lastAccessInterface);
 			lastAccessInterface.load(currentSource);
 
@@ -162,9 +183,9 @@
 			return LoopAction.Continue;
 		} else if (status == Status.BeforeUnknown) {
-			logger.info("Omitting unknown object: " + lastUnknownObjectName);
+			log.warn("omitting unknown object: " + lastUnknownObjectName);
 
 			// found unknown object
 			emptyParam.load(currentSource);
-			status = Status.AfterObject;
+			setStatus(Status.AfterObject);
 
 			return LoopAction.Continue;
@@ -185,5 +206,5 @@
 					int beg = line.indexOf('\"');
 					if (beg == -1) {
-						logger.info("Wanted to include some file, but the format is incorrect");
+						log.info("Wanted to include some file, but the format is incorrect");
 						return LoopAction.Continue;
 					}
@@ -192,5 +213,5 @@
 					int end = includeFileName.indexOf('\"');
 					if (end == -1) {
-						logger.info("Wanted to include some file, but the format is incorrect");
+						log.info("Wanted to include some file, but the format is incorrect");
 						return LoopAction.Continue;
 					}
@@ -235,12 +256,16 @@
 			if (lastAccessInterface != null) {
 				if (isBreakCondition(Status.BeforeObject)) {
-					logger.info("Breaking before object");
+					log.debug("breaking before object");
 					return LoopAction.Break;
+				} else {
+					return LoopAction.Continue;
 				}
 			} else {
 				lastUnknownObjectName = typeName;
 				if (isBreakCondition(Status.BeforeUnknown)) {
-					logger.info("Breaking before unknown");
+					log.debug("breaking before unknown");
 					return LoopAction.Break;
+				} else {
+					return LoopAction.Continue;
 				}
 			}
@@ -279,9 +304,10 @@
 
 	private void finish() {
+		log.trace("finishing");
 		if (currentSource != null) {
 			currentSource.close();
 		}
 
-		status = Status.Finished;
+		setStatus(Status.Finished);
 	}
 
@@ -291,8 +317,8 @@
 
 	public boolean setNewSource(SourceInterface source) {
-		logger.debug("switching current source to " + source.getFilename() + "...");
+		log.debug("switching current source to " + source.getFilename() + "...");
 
 		currentSource = source;
-		status = Status.Loading;
+		setStatus(Status.Loading);
 
 		return true;
@@ -311,10 +337,10 @@
 		// check if it is already included and break if it is
 		if (isAlreadyIncluded(includeFilename)) {
-			logger.debug("circular reference ignored (" + includeFilename
+			log.debug("circular reference ignored (" + includeFilename
 					+ ")");
 			return;
 		}
 
-		logger.info("including file " + includeFilename + "...");
+		log.info("including file " + includeFilename + "...");
 
 		SourceInterface newSource = currentSource.openInclude(includeFilename);
@@ -335,5 +361,5 @@
 		for (String file : fileStack) {
 			if (filename.equals(file)) {
-				logger.warn("file " + filename + " was already included");
+				log.warn("file " + filename + " was already included");
 				return true;
 			}
@@ -366,14 +392,15 @@
 	 */
 	private boolean isBreakCondition(Status condition) {
-		status = condition;
+		setStatus(condition);
 		return breakConditions.contains(condition);
 	}
 
 	public Object returnObject() {
+		assert lastAccessInterface != null;
 		Object result = lastAccessInterface.getSelected();
 		if (result == null) {
 			return null;
 		}
-        lastAccessInterface.select(null);
+		lastAccessInterface.select(null);
 		return result;
 	}
Index: /java/main/src/main/java/com/framsticks/parsers/Savers.java
===================================================================
--- /java/main/src/main/java/com/framsticks/parsers/Savers.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/parsers/Savers.java	(revision 86)
@@ -10,6 +10,6 @@
 	public static void saveFramsClass(SinkInterface sink, FramsClass framsClass) {
 
-		AccessInterface framsClassAccess = new ReflectionAccess(FramsClass.class, FramsClass.getFramsClass());
-		AccessInterface paramAccess = new ReflectionAccess(Param.class, Param.getFramsClass());
+		AccessInterface framsClassAccess = new ReflectionAccess(FramsClass.class);
+		AccessInterface paramAccess = new ReflectionAccess(Param.class);
 		framsClassAccess.select(framsClass);
 		framsClassAccess.save(sink);
Index: /java/main/src/main/java/com/framsticks/portals/Portal.java
===================================================================
--- /java/main/src/main/java/com/framsticks/portals/Portal.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/portals/Portal.java	(revision 86)
@@ -2,5 +2,6 @@
 
 import com.framsticks.observers.Observer;
-import com.framsticks.params.FramsClass;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.PeriodicTask;
 import org.apache.log4j.Logger;
@@ -10,8 +11,10 @@
  * @author Piotr Sniegowski
  */
+@FramsClassAnnotation
 public class Portal extends Observer {
 
 	private final static Logger log = Logger.getLogger(Portal.class.getName());
 
+	@ParamAnnotation
 	public Integer counter = 0;
 
@@ -38,10 +41,8 @@
 	}
 
+	@ParamAnnotation(id = "counter_squared", name = "Counter Squared")
 	public Double getCounterSquared() {
 		return (double)(counter * counter);
 	}
 
-	public static void constructFramsClass(FramsClass.Constructor constructor) {
-		constructor.method("getCounterSquared").field("counter");
-	}
 }
Index: /java/main/src/main/java/com/framsticks/util/FramsticksException.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/FramsticksException.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/util/FramsticksException.java	(revision 86)
@@ -0,0 +1,54 @@
+package com.framsticks.util;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import com.framsticks.util.lang.Delimeted;
+import com.framsticks.util.lang.Pair;
+
+@SuppressWarnings("serial")
+public class FramsticksException extends RuntimeException {
+
+	protected List<Pair<String, Object>> arguments;
+	protected String message;
+
+	public FramsticksException() {
+		super("framsticks exception");
+	}
+
+	public FramsticksException msg(String message) {
+		this.message = message;
+		return this;
+	}
+
+	public FramsticksException cause(Throwable cause) {
+		initCause(cause);
+		return this;
+	}
+
+	public FramsticksException arg(String header, Object argument) {
+		if (arguments == null) {
+			arguments = new ArrayList<>();
+		}
+		arguments.add(new Pair<String, Object>(header, argument));
+		return this;
+	}
+
+	public String getMessage() {
+		StringBuilder b = new StringBuilder();
+		if (message != null) {
+			b.append(message);
+		}
+		if (arguments != null) {
+			if (message != null) {
+				b.append(" ");
+			}
+			Delimeted d = new Delimeted(", ", "");
+			d.append(arguments.iterator());
+
+			b.append("(").append(d.build()).append(")");
+		}
+		return b.toString();
+	}
+
+}
Index: /java/main/src/main/java/com/framsticks/util/lang/Containers.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/lang/Containers.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/util/lang/Containers.java	(revision 86)
@@ -4,5 +4,7 @@
 import java.util.Iterator;
 import java.util.List;
+
 import org.apache.commons.collections.functors.InstanceofPredicate;
+import org.apache.commons.collections.functors.NotPredicate;
 import org.apache.commons.collections.iterators.FilterIterator;
 
@@ -20,22 +22,18 @@
 	}
 
-	@SuppressWarnings("unchecked")
 	public static <T> Iterable<T> filterInstanceof(Iterator<? super T> i, Class<T> type) {
 		return new IterableIterator<T>(new FilterIterator(i, new InstanceofPredicate(type)));
 	}
 
-	@SuppressWarnings("unchecked")
 	public static <T> Iterable<T> filterInstanceof(Iterable<? super T> i, Class<T> type) {
 		return new IterableIterator<T>(new FilterIterator(i.iterator(), new InstanceofPredicate(type)));
 	}
 
-	@SuppressWarnings("unchecked")
 	public static <T> Iterable<T> filterInstanceof(Collection<? super T> c, Class<T> type) {
 		return new IterableIterator<T>(new FilterIterator(c.iterator(), new InstanceofPredicate(type)));
 	}
 
-	// @SuppressWarnings("unchecked")
-	// public static <T> Iterable<T> filterNotInstanceof(Collection<T> c, Class<? extends T> type) {
-	// 	return new IterableIterator<T>(new FilterIterator(c.iterator(), new NotPredicate(new InstanceofPredicate(type))));
-	// }
+	public static <T> Iterable<T> filterNotInstanceof(Collection<T> c, Class<? extends T> type) {
+		return new IterableIterator<T>(new FilterIterator(c.iterator(), new NotPredicate(new InstanceofPredicate(type))));
+	}
 }
Index: /java/main/src/main/java/com/framsticks/util/lang/Delimeted.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/lang/Delimeted.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/util/lang/Delimeted.java	(revision 86)
@@ -1,3 +1,5 @@
 package com.framsticks.util.lang;
+
+import java.util.Iterator;
 
 import org.apache.commons.collections.Closure;
@@ -27,4 +29,11 @@
 	}
 
+	public final Delimeted append(Iterator<?> i) {
+		while (i.hasNext()) {
+			append(i.next());
+		}
+		return this;
+	}
+
 	public final String build() {
 		return (builder != null ? builder.toString() : empty);
Index: /java/main/src/main/java/com/framsticks/util/lang/IterableIterator.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/lang/IterableIterator.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/util/lang/IterableIterator.java	(revision 86)
@@ -30,6 +30,7 @@
 	// }
 
+
 	@SuppressWarnings("unchecked")
-	public IterableIterator(Iterator<? extends T> i) {
+	public IterableIterator(Iterator<?> i) {
 		this.i = (Iterator<T>) i;
 	}
Index: /java/main/src/main/java/com/framsticks/util/lang/Pair.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/lang/Pair.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/util/lang/Pair.java	(revision 86)
@@ -15,5 +15,5 @@
 	@Override
 	public String toString() {
-		return Strings.toStringNullProof(first) + " " + Strings.toStringNullProof(second);
+		return Strings.toStringNullProof(first) + " : " + Strings.toStringNullProof(second);
 	}
 
Index: /java/main/src/main/java/com/framsticks/util/lang/Strings.java
===================================================================
--- /java/main/src/main/java/com/framsticks/util/lang/Strings.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/util/lang/Strings.java	(revision 86)
@@ -42,3 +42,11 @@
 		}
 	}
+
+	public static String capitalize(String input) {
+		return input.substring(0, 1).toUpperCase() + input.substring(1);
+	}
+
+	public static String uncapitalize(String input) {
+		return input.substring(0, 1).toLowerCase() + input.substring(1);
+	}
 }
Index: /java/main/src/test/java/com/framsticks/model/CreatureTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/model/CreatureTest.java	(revision 86)
+++ /java/main/src/test/java/com/framsticks/model/CreatureTest.java	(revision 86)
@@ -0,0 +1,54 @@
+package com.framsticks.model;
+
+import org.testng.annotations.Test;
+
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.FramsClassBuilder;
+import com.framsticks.params.ReflectionAccess;
+import com.framsticks.params.types.ArrayListParam;
+import com.framsticks.params.types.DecimalParam;
+import com.framsticks.params.types.StringParam;
+import com.framsticks.test.TestConfiguration;
+
+import static org.fest.assertions.Assertions.*;
+
+@Test
+public class CreatureTest extends TestConfiguration {
+
+	FramsClass framsClass;
+	ArrayListParam partsParam;
+	ReflectionAccess access;
+	Creature creature;
+
+	@Test
+	public void testFramsClass() {
+		framsClass = FramsClassBuilder.buildForClass(Creature.class);
+
+		assertThat(framsClass).describedAs("framsClass").isNotNull();
+		assertThat(framsClass.getParam("name")).describedAs("name").isInstanceOf(StringParam.class);
+		assertThat(framsClass.getParam("parts")).describedAs("parts").isInstanceOf(ArrayListParam.class);
+		partsParam = framsClass.getParamEntry("parts", ArrayListParam.class);
+		assertThat(partsParam).describedAs("partsParam").isNotNull();
+		assertThat(partsParam).isInstanceOf(ArrayListParam.class);
+		assertThat(partsParam.getContainedTypeName()).isEqualTo("Part");
+		assertThat(framsClass.getParam("gnum")).isInstanceOf(DecimalParam.class);
+	}
+
+	@Test
+	public void testReflectionAccess() throws IllegalArgumentException, IllegalAccessException, NoSuchFieldException, SecurityException {
+		access = new ReflectionAccess(Creature.class, framsClass);
+		Object object = access.createAccessee();
+		assertThat(object).isInstanceOf(Creature.class);
+		access.select(object);
+
+		creature = (Creature) object;
+		access.set("gnum", new Integer(1));
+		// Creature.class.getField("generation").set(creature, 1);
+		assertThat(creature.generation).isEqualTo(1);
+
+
+	}
+
+
+
+}
Index: /java/main/src/test/java/com/framsticks/model/PackageTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/model/PackageTest.java	(revision 86)
+++ /java/main/src/test/java/com/framsticks/model/PackageTest.java	(revision 86)
@@ -0,0 +1,54 @@
+package com.framsticks.model;
+
+import java.io.InputStream;
+
+import org.testng.annotations.DataProvider;
+import org.testng.annotations.Test;
+
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.ReflectionAccess;
+import com.framsticks.params.SourceInterface;
+import com.framsticks.parsers.FileSource;
+import com.framsticks.parsers.Loaders;
+import com.framsticks.test.TestConfiguration;
+
+import static org.fest.assertions.Assertions.*;
+
+@Test
+public class PackageTest extends TestConfiguration {
+
+	@Test(dataProvider = "classesList")
+	public void testFramsClass(Class<?> javaClass, String name, int paramCount) throws InstantiationException, IllegalAccessException {
+		// log.info("testing " + name + " " + javaClass + " " + Package.class.getResource(filename));
+		String filename = "/info/" + name + ".info";
+		InputStream stream = Package.class.getResourceAsStream(filename);
+		assertThat(stream).describedAs("stream " + filename).isNotNull();
+
+		SourceInterface source = new FileSource(stream, filename);
+
+		assertThat(source.isClosed()).isFalse();
+		FramsClass framsClass = Loaders.loadFramsClass(source);
+		assertThat(framsClass).isNotNull();
+
+		assertThat(framsClass.getParamCount()).isEqualTo(paramCount);
+		ReflectionAccess access = new ReflectionAccess(javaClass, framsClass);
+		Object object = javaClass.newInstance();
+		access.select(object);
+	}
+
+	@DataProvider
+	public Object[][] classesList() {
+		return new Object[][] {
+			{ MechPart.class, "MechPart", 20 },
+			{ Joint.class, "Joint", 16 },
+			{ MechJoint.class, "MechJoint", 10 },
+			{ Neuro.class, "Neuro", 21},
+			{ NeuroDef.class, "NeuroDef", 9},
+			{ Part.class, "Part", 18},
+			// { Model.class, "Model" },
+			{ Creature.class, "Creature", 64 },
+			{ Genotype.class, "Genotype", 37 },
+			{ World.class, "World", 10 }
+		};
+	}
+}
Index: /java/main/src/test/java/com/framsticks/params/ParamBuilderTest.java
===================================================================
--- /java/main/src/test/java/com/framsticks/params/ParamBuilderTest.java	(revision 86)
+++ /java/main/src/test/java/com/framsticks/params/ParamBuilderTest.java	(revision 86)
@@ -0,0 +1,50 @@
+package com.framsticks.params;
+
+import org.testng.annotations.Test;
+
+import com.framsticks.params.types.FloatParam;
+import com.framsticks.params.types.StringParam;
+import com.framsticks.parsers.MultiParamLoader;
+import com.framsticks.test.TestConfiguration;
+import static org.fest.assertions.Assertions.*;
+
+@Test
+public class ParamBuilderTest extends TestConfiguration {
+
+	ParamBuilder builder;
+	FramsClass builderFramsClass;
+	AccessInterface access;
+
+	@Test
+	public void createBuilderFramsClass() {
+		builderFramsClass = FramsClassBuilder.buildForClass(ParamBuilder.class);
+
+		assertThat(builderFramsClass.getParamCount()).isEqualTo(6);
+		assertThat(builderFramsClass.getName()).isEqualTo("prop");
+		assertThat(builderFramsClass.getId()).isEqualTo("prop");
+		assertThat(builderFramsClass.getParamEntry("id", Param.class)).isInstanceOf(StringParam.class);
+	}
+
+	@Test(dependsOnMethods = { "createBuilderFramsClass" })
+	public void loadParam() throws Exception {
+		access = new ReflectionAccess(ParamBuilder.class, builderFramsClass);
+		SourceInterface source = ListSource.createFrom("prop:", "id:v", "name:variable", "type:f", "help:just a testing variable", "");
+
+		MultiParamLoader loader = new MultiParamLoader();
+		loader.setNewSource(source);
+		loader.addAccessInterface(access);
+		loader.addBreakCondition(MultiParamLoader.Status.AfterObject);
+
+		MultiParamLoader.Status status = loader.go();
+
+		assertThat(status).isEqualTo(MultiParamLoader.Status.AfterObject);
+		Object object = loader.returnObject();
+		assertThat(object).isInstanceOf(ParamBuilder.class);
+
+		builder = (ParamBuilder) object;
+
+		Param param = builder.finish();
+		assertThat(param).isInstanceOf(FloatParam.class);
+	}
+
+}
Index: /java/main/src/test/resources/info/Creature.info
===================================================================
--- /java/main/src/test/resources/info/Creature.info	(revision 86)
+++ /java/main/src/test/resources/info/Creature.info	(revision 86)
@@ -0,0 +1,423 @@
+class:
+id:Creature
+
+prop:
+name:Name
+id:name
+type:s
+flags:0
+
+prop:
+name:Genotype
+id:genotype
+type:s
+flags:0
+
+prop:
+name:Info
+id:info
+type:s
+help:Additional info or comments
+flags:0
+
+prop:
+name:group
+id:group
+type:x
+flags:33
+
+prop:
+name:Generation
+id:gnum
+type:d
+flags:0
+
+prop:
+name:Build problems
+id:buildproblems
+type:d
+flags:32
+
+prop:
+name:Starting energy
+id:energ0
+type:f
+flags:0
+
+prop:
+name:Idle power consumption
+id:idleen
+type:f
+flags:0
+
+prop:
+name:Energy
+id:energy
+type:f
+flags:0
+
+prop:
+name:Energy income
+id:energy_p
+type:f
+flags:0
+
+prop:
+name:Energy costs
+id:energy_m
+type:f
+flags:0
+
+prop:
+name:Energy balance
+id:energy_b
+type:f
+flags:0
+
+prop:
+name:Performance calculation
+id:perf
+type:d
+help:Initial value of this property is taken from Population.enableperf
+flags:0
+
+prop:
+name:NN enabled
+id:nnenabled
+type:d 0 1
+flags:0
+
+prop:
+name:Body simulation
+id:bodysim
+type:d 0 1
+help:~
+(Physical) body simulation can be disabled for individual objects which makes them immovable. Disabled objects can still participate in collisions depending on their collisions masks.
+
+Bugs: the standard collision handler does not work for disabled objects when ODE simulation is used. It means that these objects won't physically interact with other objects. The custom (scripting) handlers work as expected.~
+flags:0
+
+prop:
+name:Self-collisions
+id:selfcol
+type:d 0 1
+help:Enable/disable detection of self-collisions (within a creature body). They can only occur when using the ODE simulation engine. If enabled, the creature will have its sticks collide during lifespan.
+flags:0
+
+prop:
+name:Self-collisions
+id:selfcolstate
+type:d 0 1
+help:Current self-collision state
+flags:35
+
+prop:
+name:Life span
+id:lifespan
+type:d
+flags:0
+
+prop:
+name:Distance
+id:distance
+type:f
+flags:0
+
+prop:
+name:Velocity
+id:c_velocity
+type:f
+flags:0
+
+prop:
+name:Vertical velocity
+id:c_vertvelocity
+type:f
+flags:0
+
+prop:
+name:Vertical position
+id:c_vertpos
+type:f
+flags:0
+
+prop:
+name:Avg. velocity
+id:velocity
+type:f
+flags:0
+
+prop:
+name:Avg. vertical position
+id:vertpos
+type:f
+flags:0
+
+prop:
+name:Avg. vertical velocity
+id:vertvel
+type:f
+flags:0
+
+prop:
+name:position.x
+id:pos_x
+type:f
+help:(pos_x,pos_y,pos_z) is the point of minimal coordinates ("bottom left corner") of the creature, including imaginary Part sizes (Part.s, usually 1.0). See also: Creature.moveAbs
+flags:3
+
+prop:
+name:position.y
+id:pos_y
+type:f
+help:See Creature.pos_x
+flags:3
+
+prop:
+name:position.z
+id:pos_z
+type:f
+help:See Creature.pos_x
+flags:3
+
+prop:
+name:bounding box x size
+id:size_x
+type:f
+help:~
+(size_x,size_y,size_z) are dimensions of the axis-aligned bounding box of the creature, including the imaginary part sizes (Part.s, usually 1.0). A creature consisting of a single default Part has the size of (2.0,2.0,2.0) - twice the Part.s value (like a sphere diameter is twice its radius).
+See also: Creature.moveAbs~
+flags:3
+
+prop:
+name:bounding box y size
+id:size_y
+type:f
+help:See Creature.size_x
+flags:3
+
+prop:
+name:bounding box z size
+id:size_z
+type:f
+help:See Creature.size_x
+flags:3
+
+prop:
+name:center.x
+id:center_x
+type:f
+help:Center of gravity
+flags:3
+
+prop:
+name:center.y
+id:center_y
+type:f
+help:Center of gravity
+flags:3
+
+prop:
+name:center.z
+id:center_z
+type:f
+help:Center of gravity
+flags:3
+
+prop:
+name:number of parts
+id:numparts
+type:d
+flags:3
+
+prop:
+name:number of joints
+id:numjoints
+type:d
+flags:3
+
+prop:
+name:number of neurons
+id:numneurons
+type:d
+flags:3
+
+prop:
+name:User field 1
+id:user1
+type:x
+flags:0
+
+prop:
+name:User field 2
+id:user2
+type:x
+flags:0
+
+prop:
+name:User field 3
+id:user3
+type:x
+flags:0
+
+prop:
+name:move
+id:move
+type:p
+help:Shift the creature by a given vector.
+flags:32
+
+prop:
+name:move to absolute location
+id:moveAbs
+type:p
+help:~
+Moves the creature so that its origin (pos_x,pos_y,pos_z) is placed at the given location. The origin is the point of minimal coordinates ("bottom left corner"), including imaginary part sizes (Part.s, usually 1.0).
+Assuming a simple single-stick creature "X" having parts at (0,0,0) and (1,0,0),
+
+origin (pos_x,pos_y,pos_z) = (-1,-1,-1)
+size (size_x,size_y,size_z) = (3,2,2)
+
+The following example places the bottom of a creature at a given location (x,y,z):
+Creature.moveAbs(x-(Creature.size_x/2),y-(Creature.size_y/2),z-1.0)
+(assuming that the part size is 1.0)~
+flags:32
+
+prop:
+name:move in local coordinates
+id:moveLocal
+type:p
+help:Local coordinates are measured with respect to the position and orientation of the first Part
+flags:32
+
+prop:
+name:return world coordinates
+id:localToWorld
+type:p
+help:Local coordinates are measured with respect to the position and orientation of the first Part
+flags:32
+
+prop:
+name:return local coordinates
+id:worldToLocal
+type:p
+help:Local coordinates are measured with respect to the position and orientation of the first Part
+flags:32
+
+prop:
+name:rotate
+id:rotate
+type:p
+help:Rotate the creature around X, Y and Z axes. Should only be used immediately after creating a new creature (before the first simulation step is performed for this creature), otherwise further simulation can be disturbed.
+flags:32
+
+prop:
+name:rotate in local coordinates
+id:rotateLocal
+type:p
+help:Rotate the creature around (local) X, Y and Z axes. Should only be used immediately after creating a new creature (before the first simulation step is performed for this creature), otherwise further simulation can be disturbed.
+flags:32
+
+prop:
+name:getPart (static Model information)
+id:getPart
+type:p
+flags:32
+
+prop:
+name:getJoint (static Model information)
+id:getJoint
+type:p
+flags:32
+
+prop:
+name:getNeuroDef
+id:getNeuroDef
+type:p
+flags:32
+
+prop:
+name:getMechPart (current properties)
+id:getMechPart
+type:p
+flags:32
+
+prop:
+name:getMechJoint (current properties)
+id:getMechJoint
+type:p
+flags:32
+
+prop:
+name:getNeuro
+id:getNeuro
+type:p
+flags:32
+
+prop:
+name:Collision mask (self)
+id:selfmask
+type:db
+flags:32
+
+prop:
+name:Collision mask (other)
+id:othermask
+type:db
+flags:32
+
+prop:
+name:currentGeometryAsF0
+id:currentGeometryAsF0
+type:p
+flags:32
+
+prop:
+name:#
+id:uid
+type:s
+flags:33
+
+prop:
+name:Index
+id:index
+type:d
+help:Index of this Creature in its Population.
+flags:1
+
+prop:
+name:Model Parts
+id:parts
+type:l Part
+flags:0
+
+prop:
+name:Model Joints
+id:joints
+type:l Joint
+flags:0
+
+prop:
+name:Neuron Definitions
+id:neurodefs
+type:l NeuroDef
+flags:0
+
+prop:
+name:Simulated Parts
+id:mechparts
+type:l MechPart
+flags:0
+
+prop:
+name:Simulated Joints
+id:mechjoints
+type:l MechJoint
+flags:0
+
+prop:
+name:Live Neurons
+id:neurons
+type:l Neuro
+flags:0
+
Index: /java/main/src/test/resources/info/Genotype.info
===================================================================
--- /java/main/src/test/resources/info/Genotype.info	(revision 86)
+++ /java/main/src/test/resources/info/Genotype.info	(revision 86)
@@ -0,0 +1,232 @@
+class:
+id:Genotype
+
+prop:
+name:Name
+id:name
+type:s
+flags:0
+
+prop:
+name:Genotype
+id:genotype
+type:s
+flags:0
+
+prop:
+name:Info
+id:info
+type:s
+help:Additional information or comments
+flags:0
+
+prop:
+name:Similarity
+id:simi
+type:f
+flags:3
+
+prop:
+name:Starting energy
+id:energ0
+type:f
+flags:3
+
+prop:
+name:Body parts (deprecated; use numparts)
+id:strsiz
+type:f
+flags:35
+
+prop:
+name:Body joints (deprecated; use numjoints)
+id:strjoints
+type:f
+flags:35
+
+prop:
+name:Brain size (deprecated; use numneurons)
+id:nnsiz
+type:f
+flags:35
+
+prop:
+name:Brain connections (deprecated; use numconnections)
+id:nncon
+type:f
+flags:35
+
+prop:
+name:Body parts
+id:numparts
+type:f
+flags:3
+
+prop:
+name:Body joints
+id:numjoints
+type:f
+flags:3
+
+prop:
+name:Brain size
+id:numneurons
+type:f
+flags:3
+
+prop:
+name:Brain connections
+id:numconnections
+type:f
+flags:3
+
+prop:
+name:Ordinal number
+id:num
+type:d
+flags:0
+
+prop:
+name:Generation
+id:gnum
+type:d
+flags:0
+
+prop:
+name:Deprecated; use instances
+id:popsiz
+type:d
+flags:32
+
+prop:
+name:Instances
+id:instances
+type:d
+help:Copies of this genotype
+flags:2
+
+prop:
+name:Life span
+id:lifespan
+type:f
+help:Average life span
+flags:0
+
+prop:
+name:Velocity
+id:velocity
+type:f
+help:Average velocity
+flags:0
+
+prop:
+name:Distance
+id:distance
+type:f
+flags:0
+
+prop:
+name:Vertical velocity
+id:vertvel
+type:f
+flags:0
+
+prop:
+name:Vertical position
+id:vertpos
+type:f
+flags:0
+
+prop:
+name:Fitness
+id:fit
+type:f
+flags:3
+
+prop:
+name:Final fitness
+id:fit2
+type:f
+help:Fitness shifted by (avg-n*stddev)
+flags:3
+
+prop:
+name:f0 genotype
+id:f0genotype
+type:s
+help:converted to f0 genotype
+flags:3
+
+prop:
+name:Conversion backtrace [1]
+id:convtrace1
+type:s
+flags:3
+
+prop:
+name:User field 1
+id:user1
+type:x
+flags:0
+
+prop:
+name:User field 2
+id:user2
+type:x
+flags:0
+
+prop:
+name:User field 3
+id:user3
+type:x
+flags:0
+
+prop:
+name:Mutate
+id:mutate
+type:p
+flags:0
+
+prop:
+name:Valid
+id:isValid
+type:d 0 1
+flags:35
+
+prop:
+name:get normalized property
+id:getNormalized
+type:p
+flags:35
+
+prop:
+name:#
+id:uid
+type:s
+help:Unique identifier
+flags:33
+
+prop:
+name:Model object
+id:getModel
+type:p
+flags:35
+
+prop:
+name:Model Parts
+id:parts
+type:l Part
+flags:0
+
+prop:
+name:Model Joints
+id:joints
+type:l Joint
+flags:0
+
+prop:
+name:Neuron Definitions
+id:neurodefs
+type:l NeuroDef
+flags:0
+
Index: /java/main/src/test/resources/info/Joint.info
===================================================================
--- /java/main/src/test/resources/info/Joint.info	(revision 86)
+++ /java/main/src/test/resources/info/Joint.info	(revision 86)
@@ -0,0 +1,99 @@
+class:
+id:Joint
+
+prop:
+name:part1 ref#
+id:p1
+type:d
+flags:1024
+
+prop:
+name:part2 ref#
+id:p2
+type:d
+flags:1024
+
+prop:
+name:rotation.x
+id:rx
+type:f
+flags:0
+
+prop:
+name:rotation.y
+id:ry
+type:f
+flags:1024
+
+prop:
+name:rotation.z
+id:rz
+type:f
+flags:1024
+
+prop:
+name:delta.x
+id:dx
+type:f
+flags:0
+
+prop:
+name:delta.y
+id:dy
+type:f
+flags:1024
+
+prop:
+name:delta.z
+id:dz
+type:f
+flags:1024
+
+prop:
+name:stiffness
+id:stif
+type:f
+flags:0
+
+prop:
+name:rotation stiffness
+id:rotstif
+type:f
+flags:0
+
+prop:
+name:stamina
+id:stam
+type:f
+flags:0
+
+prop:
+name:info
+id:i
+type:s
+flags:0
+
+prop:
+name:vis_style
+id:Vstyle
+type:s
+flags:0
+
+prop:
+name:red component
+id:vr
+type:f
+flags:0
+
+prop:
+name:green component
+id:vg
+type:f
+flags:1024
+
+prop:
+name:blue component
+id:vb
+type:f
+flags:1024
+
